(*
	Princpool.ml
	26/05/2003
	Giacomo Baldi

	Implementation of a principal pool.

*)

open Utils
open Principal

exception NoMorePrinc

type ppool = (principal list) * int


let create = function p  -> function n -> (p,n)


let getmax =
	function (pp,max) -> max
	
let howmany =
	function (pp,max) -> Utils.len pp

let getprinc =
	function (pp,max) ->
	function n ->
	function i ->
		if i>max then raise NoMorePrinc
		else
			try (
				let (name,index,vlist,e) = select pp n in
					Principal.create (name, i, vlist, e)
			) with UtilException -> raise NoMorePrinc
