(*
	Action.ml
	30/01/2003
	Giacomo Baldi

	Implementation of actions.
*)

open Message
open Assignment


type action =
  | Input of pname*msg*assignment
  | Output of pname*msg*assignment
  | Join of pname*assignment
  | NoMoreAct
  | Closed

let equal =
  function x ->
    function y ->
      match x,y with
      | Input(p1,m1,s1), Input(p2,m2,s2) -> (s1 m1) = (s2 m2)
      | Output(p1,m1,s1), Output(p2,m2,s2) -> (s1 m1) = (s2 m2)
      | NoMoreAct, NoMoreAct -> true
      | _ -> false

let prnt =
  function a ->
    match a with
    | Input((sn,i),m,s) ->
	(
	 print_string(sn^"_"^string_of_int(i)^": In(");
	 prntMsg m;
	 print_string(")  --sigma-->  In(");
	 prntMsg (s m);
	 print_string(")\n")
	)
    | Output((sn,i),m,s) ->
	(
	 print_string(sn^"_"^string_of_int(i)^": Out(");
	 prntMsg m;
	 print_string(")  --sigma-->  Out(");
	 prntMsg (s m);
	 print_string(")\n")
	)
    | Join(pn,asg) ->
	(
	 print_string("Join: "^fst(pn)^"_"^string_of_int(snd(pn))^"\n")
	)
    | NoMoreAct -> print_string("0\n")

let tostring =
	function a ->
		match a with
			| Input((sn,i),m,s) -> sn^"_"^string_of_int(i)^": I("^(Message.tostring (s m))^")"
			| Output((sn,i),m,s) -> sn^"_"^string_of_int(i)^": O("^(Message.tostring (s m))^")"
			| Join(p,s) -> "J("^fst(p)^","^string_of_int(snd(p))^")"
			| NoMoreAct -> "0"
