(*
	parsecmdline.mli
	25/05/2003
	Giacomo Baldi

	Definition of command line parsing functions
*)
type graphopt = {
	mutable context: bool;
	mutable actions: bool;
	mutable k: bool;
	mutable asg: bool;
        mutable level: int;
}

type options = {
    mutable output_type: int;			(* -T, -G: 0 = traces, 1 = Gviz , 2 = NoOutput *)
    mutable attack_type: int;                   (* 0: ascii, 1: latex 2:html*)  
    mutable pr_file: string;			(* needed *)
    mutable pl_file: string;			(* needed *)
    mutable pj_file: string;                    (* needed *)
    mutable kb_file: string;			(* needed *)
    mutable trace_terminal: bool;		(* --terminal | -t: default false *)
    mutable go: graphopt;						(* -Gcontext -Gknowledge -Gassignment -Gactions *)
    mutable errmsg: string;
    mutable help: bool;
    mutable max_princ: int; 				(* -max num: maximun number of principals in context *)
    mutable interactive: bool;
    mutable feedback: bool;
    mutable lazyness: bool;
    mutable mga: bool;
    mutable ic: int list;
    mutable greed: bool;
  }



val init_options: unit -> options
val parsecmdline: string array -> options -> unit
val synopsis: bool -> unit

val htmlinit: unit -> unit
val htmldone: unit -> unit

