(*
	principal.mli
	30/01/2003
	Giacomo Baldi
	
	Definition of a principal.

*)

(**
   This module implements the princiapl structure.
*)

open Process
open Assignment
open Message

(**
   A principal is made of a name, and index, a list of open variables and a process.
*)
type principal = string*int*(variable list)*process

(**
   create a new principal
*)
val create: string*int*(variable list)*process -> principal

(**
   
*)
val substitute: assignment -> principal -> principal
val isConsumed: principal -> bool
val getName: principal -> string*int
val getVars: principal -> msg list
val check: principal -> bool
val len: principal -> int
val typeOf: principal -> variable -> svtype

val prnt: principal -> assignment -> unit
val prntHtml: principal -> assignment -> unit
val tostring: principal -> assignment -> string

