(*
   tracer.mli
   30/08/2003
   Giacomo Baldi
   
   definitions of functions and constants for state space search.
*)

(**
   This module provides functions and values to perform search in state space
*)

open Message
open Principal
open Kmanager
open Node
open Parsecmdline
open Logic
open H_var

type ss

val init_search: principal list -> msg list -> options -> ss 

val do_joins: ss -> pls -> pls -> unit
val do_search: ss -> unit

val print_stats: ss -> unit
val prerr_stats: ss -> unit
