(*
	verifier.mli
	25/07/2003
	Giacomo Baldi

	Interface for verifier.ml
	Definition of verifier signature

*)
open Logic
open Assignment
open Node
open Kmanager
open Csolver

val checkplf: npls -> cs -> km -> node -> (npls*assignment*cs) list
val checkplt: npls -> cs -> km -> node -> (npls*assignment*cs) list
val getmodels: npls -> km -> node -> (assignment*cs) list
val getemptymodel: unit -> assignment*cs

val fast_checkpl: npls -> cs -> km -> node -> (pls list)*((npls*assignment*cs) list)
val fast_sat_model: npls -> cs -> km -> node -> bool
val fast_sat: npls -> km -> node -> bool
