open Node
open Context
open Logic
open Assignment
open Kmanager 
open Knowledge
open Message
open Csolver

(*max is  a normal maximum function that inputs two integer values and return the maximum value*)

 let  rec max l=

let rec matt e ll =
 match ll with  
lls::llls -> if e > lls then matt e llls else matt lls llls
|[]-> e in
let d= List.hd l in 
matt d (List. tl l);;
 

let rec min l =
 match l with 
l1::ls-> if l1 < 0 then l1 else min ls
|[]-> 0

(*maxm is a function that decides if two values are positive then maximum is chosen,
however if anyone of them is negative, the negative value is returned*)
let rec maxm l = 
let maxv = max l in
let minv = min l  in 
if minv<0 then minv else maxv;;

let check n vv= 
let (ct,chi,k) = Node.getstatus n in 
let asglist = Assignment.listfy chi 
in (*List.map (fun x -> let (vvv,mmm) = x in if vv=vvv then mmm else Bottom) asglist *)
let element = (try (List.find (fun (x,y) -> x=vv)) asglist with Not_found->(Bottom,Bottom) ) in
if element = (Bottom,Bottom) then Bottom else snd (element)
 
(* returns the number of open  variables in a node*)
let varCount n = 
let (ct,chi,k)=Node.getstatus n in 
let ov=Context.getOpenVariable ct in ov

let rec check_open ol fl n =
match fl with 
Equal(v,_)::fs-> if (List.exists (fun x-> x=v) ol) then check_open ol fs (n+1) else check_open ol fs n
|Diff(v,_)::fs-> if (List.exists (fun x-> x=v) ol) then check_open ol fs (n+1) else check_open ol fs n
|Derive(_)::fs-> check_open ol fs n
|NDerive(_)::fs->check_open ol fs n
|True::fs->check_open ol fs n
|False::fs->check_open ol fs n
|[]->n


let rec remove_weight l= match l with 
(x,y)::ls-> y::remove_weight ls
|[]->[]

let rec prune l = 
match l with 
(c,d)::ll-> if c <> -1 then (c,d)::(prune ll) else prune ll 
|[]->[]



let rec order_list l = match l with 
      (a,b)::ll when a= -1 -> order_list ll
      |(a,b)::ls -> let rec comparel (x,y) nl tl =
      match nl with    
      (c,d)::nls -> if x>c then let temp =(x,y) in let 
      templ = (c,d)::tl in
      comparel temp nls templ 
      else  let temp=(c,d) in let templ = (x,y)::tl in comparel temp nls templ 
    |[]->(x,y)::tl in
    let (w,z)::zs = comparel (a,b) ls [] in
	z::order_list zs
  |[]->[]

let rec order_same ll =
match ll with 
ll1::lls-> let (v,nn)= ll1 in (List.for_all (fun (x,y) -> x = v) ll )
|[]-> false

let rec order l  = match l with 
l1::ls -> let newl= (prune l1) in let newll = (order_same newl) in (if newll =true then (remove_weight newl)::order ls else (order_list l1)::order ls)
|[]->[]
 


