(*
	Context.mli
	30/01/2003
	Giacomo Baldi
	
	A context is a collection of principal processes
*)


open Principal
open Assignment
open Message

type context

val void: unit -> context
val add: context*principal -> context
val ( ++ ): context -> (principal*principal) -> context
val getlist: context -> principal list
val setlist: principal list -> context
val getPrev: context -> context
val isEmpty: context -> bool
val hasEmptyPrincipal: context -> bool
val getprincipal: context*int -> principal
val getindexedprinc: context -> int -> assignment -> principal
val getopenprinc: context -> assignment -> principal list
val getOpenVariables: context -> int*msg list
val getIndexesOf: context -> string -> int list
val getlentrace: context -> int
val howmany: context -> int
val applyall: context -> assignment -> context

val prnt: context -> assignment -> unit
val prntHtml: context -> assignment -> unit
val tostring: context -> assignment -> string
