(*
	Node.mli
	30/01/2003
	Giacomo Baldi

	Definition of a tree node. 
*)


open Status
open Principal
open Message
open Assignment
open Process
open Action

	type redex = principal*action*principal


	type node

	val create: status -> node
	val setlabel: node*action -> unit
	val setstatus: node*status -> unit
	val setfather: node*node -> unit
	val setnd: node*int -> unit
	val setnj: node*int -> unit
	val close: node -> unit
	val setIn: node -> unit
	val setJn: node -> unit
	val settable: node*(redex list) -> unit
	val setjoins: node*(action list) -> unit
	val getlevel: node -> int
	val getlabel: node -> action
	val getSons: node -> int
	val getid: node -> int
	val getfather: node -> node
	val getnd: node -> int
	val getnj: node -> int
	val getstatus: node -> status
	val gettable: node -> (redex list)
	val getjoins: node -> (action list)
	val getRedex: node -> redex
	val getJoin: node -> action
	val isNul: node -> bool
	val isOut: node -> bool
	val isJn: node -> bool
	val isLeaf: node -> bool
	val nulNode: unit -> node
	val isTerminal: node -> bool
	val isPartiallyTerminated: node -> bool

	val prnt: node -> unit
