(*
	csolver.mli
	27/07/2003
	Giacomo Baldi

	Constraint Solver for pl verification

*)
open Message
open Assignment

type cns = PC of (msg*msg)  | NC of (msg*msg)
type cs

val init: unit -> cs
val addconstraint: cns -> cs -> cs
val addconstraints: cns list -> cs -> cs
val adddisjunct: cs -> cns list -> cs
val adddisjuncts: cns list list -> cs -> cs
val addconjuncts: cns list list -> cs -> cs
val check: cs -> bool
val linearize: cs -> cs list
val preserve_truth: cs -> cs
val prnt: cs -> unit
val prntHtml: cs -> unit
val toasg: cs -> assignment list
val positivize: (msg*msg) list -> cns list
val negativize: (msg*msg) list -> cns list

