(*
	logic.mli
	14/04/2003
	Giacomo Baldi

	Interface for logic.ml
	Definition of protocol logic representation

*)

open Message
open Node
open Assignment

type index = string
type pls =
	| Forall of index*string*pls
	| Exists of index*string*pls
	| Not of pls
	| And of pls*pls
	| Or of pls*pls
	| Equal of msg*msg
	| Diff of msg*msg
	| Derive of msg
	| NDerive of msg
	| True
	| False

type npls =
	pls list list


	val normalize: pls -> node -> npls
	val concretize: npls -> assignment -> npls
	val getatoms: npls -> npls -> pls list

	val prnt: pls -> unit
	val prntnpl: npls -> unit
	val prntHtml: pls -> unit
	val prntnplHtml: npls -> unit
