(*
	kmanager.ml
	05/04/2003
	Giacomo Baldi

	Implementation of a knowledge manager.
*)

open Message
open Assignment
open Knowledge
open Khash


exception NoKnowledge

type km = khash*(int ref)

let initKM =
  function n -> (Khash.init n, ref(-1))

let getK =
  function (kman,mid) ->
    function n ->
      let kb = Khash.get kman n in
      if Knowledge.isVoid kb then (print_string(string_of_int(n)^"\n"); raise NoKnowledge)
      else kb

let newK =
  function (kman,mid) ->
    let newk = Knowledge.expand (Knowledge.void()) (!mid+1) (Assignment.void()) in
    (
     Khash.insert kman newk;
     mid:=!mid+1;
     newk
    )

let expandK =
  function ((kman,mid),k,asg,m) ->
    let newk = Knowledge.applyall (Knowledge.learn ((Knowledge.expand (k) (!mid+1) asg),m)) asg in
    (
     Khash.insert kman newk;
     mid:=!mid+1;
     newk;
    )

let updateK =
  function (kmanage,k,asg) ->
    expandK (kmanage,k,asg,Bottom)
    
     
let size =
  function (kman,mid) -> Khash.size kman
      


(*
   type km = ((kb) Weak.t)

   let initKM =
   function n -> Weak.create (Sys.max_array_length-1)

   let getK =
   function kman ->
   function n ->
   match Weak.get kman n with
   | Some (k) -> k
   | _ -> raise NoKnowledge

   let rec findfree =
   function kman ->
   function n ->
   if (Weak.get kman n = None) then(print_string(string_of_int(n)^"\n"); n) else findfree kman (n+1)
   
   

   let newK =
   function kman ->
   let it = findfree kman 0 in
   let newk = Knowledge.expand (Knowledge.void()) (it) in
   (Weak.set kman it (Some(newk)); newk)


   let expandK =
   function (kman, k, m) ->
   let it = findfree kman 0 in
   let newk = Knowledge.learn ((Knowledge.expand (k) (it)),m) in
   (Weak.set kman it (Some(newk)); newk)

   let size =
   function kman -> 0
 *) 
      
(*
   type km = (int ref)*((kb array) ref)


   let initKM =
   function n -> (ref(-1), ref(Array.make n (Knowledge.void())))

   let getK =
   function (pos,kman) ->
   function n ->
   if ((n >= (Array.length !kman)) || (n > !pos)) then raise NoKnowledge
   else (Array.get !kman n)

   let enlarge =
   function (kman) ->
   let ns = (Array.length kman) in
   (Array.append kman (Array.make (ns/2) (Knowledge.void())))
   let rec newK =
   function ((pos,kman)) ->
   if ((!pos+1) < (Array.length !kman)) then (
   let newk = Knowledge.expand (Knowledge.void()) (!pos+1) in
   (pos:=!pos+1; Array.set !kman !pos newk; newk)
   )
   else (kman:=(enlarge !kman); newK((pos,kman)))
   let rec expandK =
   function ((pos,kman), k, m) ->
   if ((!pos+1) < (Array.length !kman)) then (
   let newk = Knowledge.learn ((Knowledge.expand (k) (!pos+1)),m) in
   (pos:=!pos+1; Array.set !kman !pos newk; newk)
   )
   else (kman:=(enlarge !kman); expandK((pos,kman),k,m) )
   
   let size = 
   function (pos,kman) -> !pos

 *)
