(*
	status.ml
	30/01/2003
	Giacomo Baldi

	Implementation of a status.

*)


open Context
open Assignment
open Knowledge
open Message

(*
	A status is a triple of a context, an assignment and a knowledge base.
	It is encapsulated in a node (node.ml) during search in state space.
	It is an image of interaction of principals.
*)
type status = context*assignment*kb

let create =
	function (ct, asg, k) -> (ct, asg, k)


(*
	if the context is empty we have a terminal status
*)
let isTerminal =
	function (ct,asg,k) -> (Context.isEmpty ct)&&(not (Assignment.isVoid asg))

let isPartiallyTerminated =
	function (ct,asg,k) -> (Context.hasEmptyPrincipal ct)&&(not (Assignment.isVoid asg))


let prnt =
	function (ct,asg,kb) ->
		print_string("Status:\n{\nContext:\n");
		Context.prnt ct asg;
		print_string("\nAssignment:\n");
		Assignment.prnt asg;
		print_string("\nKnowledge:\n");
		Knowledge.prnt kb;
		print_string("\n}\n")
